# Module `DataList`

Component to manage data for huge dataset in scroll.

It requires Druid Scroll and Druid Grid (Static or Dynamic) components

Example Link

## Functions

clear(self) | Clear the DataList and refresh visuals
get_created_components(self) | Return all currenly created components in DataList
get_created_nodes(self) | Return all currenly created nodes in DataList
get_data(self) | Return current data from DataList component
get_first_index(self) | Return first index from data.
get_index(self, data) | Return index for data value
get_last_index(self) | Return last index from data
get_length(self) | Return amount of data
init(self, scroll, grid, create_function) | The DataList constructor
on_remove(self) | Druid System on_remove function
scroll_to_index(self, index) | Instant scroll to element with passed index
set_data(self, data) | Set new data set for DataList component

## Fields

grid | The Druid Grid component
last_index | The current visual last data index
on_element_add | On DataList visual element created Event callback(self, index, node, instance)
on_element_remove | On DataList visual element created Event callback(self, index)
on_scroll_progress_change | Event triggered when scroll progress is changed; event(self, progress_value)
scroll | The Druid scroll component
scroll_progress | The current progress of scroll posititon
top_index | The current visual top data index

## Functions

clear(self)
  Clear the DataList and refresh visuals

  ### Parameters:

  - self DataList DataList
get_created_components(self)
  Return all currenly created components in DataList

  ### Parameters:

  - self DataList DataList

  ### Returns:

  druid.base_component[] List of created nodes
get_created_nodes(self)
  Return all currenly created nodes in DataList

  ### Parameters:

  - self DataList DataList

  ### Returns:

  node[] List of created nodes
get_data(self)
  Return current data from DataList component

  ### Parameters:

  - self DataList DataList

  ### Returns:

  table The current data array
get_first_index(self)
  Return first index from data. It not always equals to 1

  ### Parameters:

  - self DataList DataList
get_index(self, data)
  Return index for data value

  ### Parameters:

  - self DataList DataList
  - data table
get_last_index(self)
  Return last index from data

  ### Parameters:

  - self DataList DataList
get_length(self)
  Return amount of data

  ### Parameters:

  - self DataList DataList
init(self, scroll, grid, create_function)
  The DataList constructor

  ### Parameters:

  - self DataList DataList
  - scroll Scroll The Scroll instance for Data List component
  - grid StaticGrid or DynamicGrid The StaticGrid or DynamicGrid instance for Data List component
  - create_function function The create function callback(self, data, index, data_list). Function should return (node, [component])
on_remove(self)
  Druid System on_remove function

  ### Parameters:

  - self DataList DataList
scroll_to_index(self, index)
  Instant scroll to element with passed index

  ### Parameters:

  - self DataList DataList
  - index number
set_data(self, data)
  Set new data set for DataList component

  ### Parameters:

  - self DataList DataList
  - data table The new data array

  ### Returns:

  druid.data_list Current DataList instance

## Fields

grid
  The Druid Grid component
  - grid StaticGrid or DynamicGrid StaticGrid, DynamicGrid
last_index
  The current visual last data index
  - last_index number
on_element_add
  On DataList visual element created Event callback(self, index, node, instance)
  - on_element_add DruidEvent DruidEvent
on_element_remove
  On DataList visual element created Event callback(self, index)
  - on_element_remove DruidEvent DruidEvent
on_scroll_progress_change
  Event triggered when scroll progress is changed; event(self, progress_value)
  - on_scroll_progress_change DruidEvent DruidEvent
scroll
  The Druid scroll component
  - scroll Scroll Scroll
scroll_progress
  The current progress of scroll posititon
  - scroll_progress number
top_index
  The current visual top data index
  - top_index number

generated by LDoc TESTING Last updated 2015-01-01 12:00:00